<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/operators/FlowchartOperator_lb62b1fb4ed3f621_85788957.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/helpers/date/DateTimeFactory_lb62b1fb4ed3f621_85788957.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/helpers/date/LbDateTypes_lb62b1fb4ed3f621_85788957.php';

class DateAddOperator_lb62b1fb4ed3f621_85788957 extends FlowchartOperator_lb62b1fb4ed3f621_85788957{

    protected $date;
    protected $number;
    protected $units;

    public $result;

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->date = $params['inDataPorts']['date']['value'];
        $this->number = $params['inDataPorts']['number']['value'];
        $this->units = $params['inDataPorts']['units']['value'];

        foreach($params['inDataPorts'] as $portId => $val){
            $this->inDataPorts[$portId] = array(
                'id' => $portId
            );
        }
    }

    public function setInDataPortById($id, $value){
        if($id == 'date'){
            $this->date = $value;
        }elseif($id == 'number'){
            $this->number = $value;
        }elseif($id == 'units'){
            $this->units = $value;
        }elseif(!empty($this->inDataPorts[$id])){
            $this->inDataPorts[$id]['value'] = $value;
        }
    }

    public function process($params = array()){
        $sugarDateTime = $this->getDateTimeCopy($this->date);

        if(empty($sugarDateTime)) {
            $this->result = null;
            return;
        }

        $number = abs($this->number);

        $interval_spec = 'P';
        if($this->units == 'year')
            $interval_spec .= $number.'Y';
        elseif($this->units == 'month')
            $interval_spec .= $number.'M';
        elseif($this->units == 'quarter')
            $interval_spec .= ( $number*3 ).'M';
        elseif($this->units == 'day')
            $interval_spec .= $number.'D';
        elseif($this->units == 'week')
            $interval_spec .= ( $number*7 ).'D';
        elseif($this->units == 'hour')
            $interval_spec .= 'T'.$number.'H';
        elseif($this->units == 'minute')
            $interval_spec .= 'T'.$number.'M';


        try {
            $dateInterval = new DateInterval($interval_spec);

            if ($this->number > 0) {
                $sugarDateTime->add($dateInterval);
            } else {
                $sugarDateTime->sub($dateInterval);
            }
        }catch(Exception $e){}

        $this->result = $sugarDateTime;
    }

    public function getOutDataByPortId($portId){
        if($portId == 'result')
            return $this->result;
        else
            return $this->outDataPorts[$portId]['value'];
    }

    protected function getDateTimeCopy($date){
        return LbDateTypes_lb62b1fb4ed3f621_85788957::getDateTimeCopy($date);
    }

    protected function formatResultToUserPreferences($dateTime){
        global $timedate, $current_user;
        return $timedate->asUser($dateTime, $current_user);
    }
}
