<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/operators/FlowchartOperator_lb62b1fb4ed3f621_85788957.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/helpers/DateTimeConverter_lb62b1fb4ed3f621_85788957.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/helpers/DecimalConverter_lb62b1fb4ed3f621_85788957.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/helpers/date/DateTimeFactory_lb62b1fb4ed3f621_85788957.php';

class GetEntityAttributesOperator_lb62b1fb4ed3f621_85788957_op2 extends FlowchartOperator_lb62b1fb4ed3f621_85788957{

    protected $entityName;
    protected $emptyEntity;

    protected $entity;
    protected $attributes = array();

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->setEntityName($params['inDataPorts']['entity']['value']);

        $this->inDataPorts = array();
        foreach($params['inDataPorts'] as $key => $value)
            if($key == 'entity')
                $this->inDataPorts[$key]['id'] = $value['id'];
            else
                $this->inDataPorts[$key] = $value;
    }

    protected function setEntityName($moduleName){
        $this->entityName = $moduleName; //$beanList[$moduleName];
    }

    public function setInDataPortById($id, $value){
        if($id == 'entity'){
            $this->entity = $value;
        }else
            parent::setInDataPortById($id, $value);
    }

    public function process($params = array()){
        $this->initOutDataPortsWithAttr();
    }

    protected function initOutDataPortsWithAttr(){
        $this->checkCurrentAttrValue('list_type');
        if(isset($this->entity->list_type)){
            $this->attributes['list_type'] = $this->convertAttrValue('list_type', $this->entity->list_type);
        }else{
            $this->attributes['list_type'] = NULL;
        }
        $this->checkCurrentAttrValue('name');
        if(isset($this->entity->name)){
            $this->attributes['name'] = $this->convertAttrValue('name', $this->entity->name);
        }else{
            $this->attributes['name'] = NULL;
        }
    }

    public function getOutDataByPortId($portId){
        $field = $this->outDataPorts[$portId]['value'];
        return $this->attributes[$field];
    }

    protected function convertAttrValue($fieldName, $fieldValue){

        if($this->entity instanceof SugarBean){
            if(!empty($this->entity->field_defs[$fieldName])){
                $fieldDef = $this->entity->field_defs[$fieldName];
            }
        }else{
            if(empty($this->emptyEntity)){
                $this->emptyEntity = BeanFactory::getBean($this->entityName);
            }

            if(!empty($this->emptyEntity->field_defs[$fieldName])){
                $fieldDef = $this->emptyEntity->field_defs[$fieldName];
            }
        }

        if(empty($fieldDef))
            return $fieldValue;

        switch($fieldDef['type']){
            case 'date':
                $dateTimeFactory = new DateTimeFactory_lb62b1fb4ed3f621_85788957();
                $fieldValue = $dateTimeFactory->getDateTimeFromDbDateString($fieldValue);
                break;
            case 'datetime':
            case 'datetimecombo':
                $dateTimeFactory = new DateTimeFactory_lb62b1fb4ed3f621_85788957();
                $fieldValue = $dateTimeFactory->getDateTimeFromDbDateTimeString($fieldValue);
                break;
            case 'currency':
            case 'decimal':
            case 'double':
            case 'float':
                require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/helpers/DecimalConverter_lb62b1fb4ed3f621_85788957.php';
                $fieldValue = DecimalConverter_lb62b1fb4ed3f621_85788957::convertToDisplay($fieldDef, $fieldValue);
                break;
            case 'integer':
            case 'int':
                break;
            default:
                if(empty($fieldValue)){
                    $fieldValue = NULL;
                }
                break;
        }

        return $fieldValue;
    }

    protected function checkCurrentAttrValue($fieldName){
        if($fieldName == 'date_entered' && $this->entity instanceof SugarBean &&
            empty($this->entity->date_entered) && !empty($this->entity->fetched_row['date_entered'])){
            $this->entity->date_entered = $this->entity->fetched_row['date_entered'];
        }
    }

}
