<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/operators/FlowchartOperator_lb62b1fb4ed3f621_85788957.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb62b1fb4ed3f621_85788957/helpers/date/DateTimeFactory_lb62b1fb4ed3f621_85788957.php';

class SetEntityAttributesOperator_lb62b1fb4ed3f621_85788957_op10 extends FlowchartOperator_lb62b1fb4ed3f621_85788957{

    protected $entity;
    protected $attributes;

    public function __construct($params){
        parent::__construct($params);
    }

    public function process($params = array()){
        $this->initBeanWithInData();
    }

    protected function initBeanWithInData(){
        $fieldDef = $this->entity->field_defs['name'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->name = $this->getDateInDbFormat(
                    $this->attributes['name']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->name = $this->getDateTimeInDbFormat(
                    $this->attributes['name']
                );
                break;
            default:
                $this->entity->name = $this->attributes['name'];
            }
        $fieldDef = $this->entity->field_defs['parent_id'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->parent_id = $this->getDateInDbFormat(
                    $this->attributes['parent_id']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->parent_id = $this->getDateTimeInDbFormat(
                    $this->attributes['parent_id']
                );
                break;
            default:
                $this->entity->parent_id = $this->attributes['parent_id'];
            }
        $fieldDef = $this->entity->field_defs['assigned_user_id'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->assigned_user_id = $this->getDateInDbFormat(
                    $this->attributes['assigned_user_id']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->assigned_user_id = $this->getDateTimeInDbFormat(
                    $this->attributes['assigned_user_id']
                );
                break;
            default:
                $this->entity->assigned_user_id = $this->attributes['assigned_user_id'];
            }
        $fieldDef = $this->entity->field_defs['date_start'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->date_start = $this->getDateInDbFormat(
                    $this->attributes['date_start']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->date_start = $this->getDateTimeInDbFormat(
                    $this->attributes['date_start']
                );
                break;
            default:
                $this->entity->date_start = $this->attributes['date_start'];
            }
        $fieldDef = $this->entity->field_defs['parent_type'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->parent_type = $this->getDateInDbFormat(
                    $this->attributes['parent_type']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->parent_type = $this->getDateTimeInDbFormat(
                    $this->attributes['parent_type']
                );
                break;
            default:
                $this->entity->parent_type = $this->attributes['parent_type'];
            }
        $fieldDef = $this->entity->field_defs['description'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->description = $this->getDateInDbFormat(
                    $this->attributes['description']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->description = $this->getDateTimeInDbFormat(
                    $this->attributes['description']
                );
                break;
            default:
                $this->entity->description = $this->attributes['description'];
            }
        $fieldDef = $this->entity->field_defs['direction'];
        switch($fieldDef['type']){
            case 'date':
                $this->entity->direction = $this->getDateInDbFormat(
                    $this->attributes['direction']
                );
                break;
            case 'datetime':
            case 'datetimecombo':
                $this->entity->direction = $this->getDateTimeInDbFormat(
                    $this->attributes['direction']
                );
                break;
            default:
                $this->entity->direction = $this->attributes['direction'];
            }
    }

    private function getDateInDbFormat($value)
    {
        $date = $this->getDateTimeFromValue($value);
        if (empty($date)) {
            return null;
        }
        return $date->asDbDate(false);
    }

    private function getDateTimeInDbFormat($value)
    {
        $dateTime = $this->getDateTimeFromValue($value);
        if (empty($dateTime)) {
            return null;
        }
        return $dateTime->asDb(true);
    }

    private function getDateTimeFromValue($date)
    {
        if ($date instanceof SugarDateTime) {
            return $date;
        }
        if (!is_string($date)) {
            return null;
        }
        $dateTimeFactory = new DateTimeFactory_lb62b1fb4ed3f621_85788957();
        return $dateTimeFactory->getDateTimeFromUnknownFormat($date);
    }

    public function setInDataPortById($id, $value){
        if(!empty($this->inDataPorts[$id])){
            if($value instanceof SugarBean){
                $this->entity = $value;
            }else{
                $this->attributes[$this->inDataPorts[$id]['value']] = $value;
            }
        }
    }

    public function getOutDataByPortId($portId){
        return $this->entity;
    }

}
